
#ifndef _BASE_UDBUF_HXX
#define _BASE_UDBUF_HXX 1


/*
 *	up/down streambufs
 */

#ifndef _MM_NO_IOSTREAM
#include <iostream>

  /*
   * downstream buffer
   */
  class downbuf:public std::streambuf {
      std::streambuf *_psbDown;

      char *_pchBuf;
      char *_pchBufLim;
      char *base() { return _pchBuf; }
      char *ebuf() { return _pchBufLim; }

    protected:
      virtual int put(const char *pch, int c)=0;
      std::streambuf *psbDown() { return _psbDown; }
      int overflow(int ch);
      std::streamsize xsputn(const char *, std::streamsize);
      int sync();
      int pubsync();
      downbuf(std::streambuf *psbDown);
      ~downbuf();
  };

  /*
   * upstream buffer
   */
  class upbuf:public std::streambuf {
      std::streambuf *_psbUp;

      char *_pchBuf;
      char *_pchBufLim;
      char *base() { return _pchBuf; }
      char *ebuf() { return _pchBufLim; }
      std::streamsize blen() { return _pchBufLim-_pchBuf; }

    protected:
      int underflow();
      virtual int get(char *pch, int n) = 0;
      std::streamsize xsgetn(char *pch, std::streamsize n);
      std::streambuf *psbUp() { return _psbUp; }
      std::streamsize upsgetn(char *, std::streamsize);
      upbuf(std::streambuf *psbUp);
      ~upbuf();
  };



#endif
#endif
