/************************************************************

  Declarations from the IEEE488.2 standard

************************************************************/

#ifndef _BASE_GPIB_H
#define _BASE_GPIB_H

/* GPIB interface commands */
#define	GPIB_GTL	   0x01	/* goto local */
#define GPIB_SDC	   0x04	/* selective device clear */
#define	GPIB_PPC	   0x05	/* parallel poll configure */
#define GPIB_GET	   0x08	/* group execute trigger */
#define GPIB_TCT	   0x09	/* take control */
#define GPIB_LLO	   0x11	/* local lockout */
#define GPIB_DCL	   0x14	/* generic device clear */
#define GPIB_PPU	   0x15	/* parallel poll unconfigure */
#define GPIB_SPE	   0x18	/* serial poll enable */
#define GPIB_SPD	   0x19	/* serial poll disable */
#define GPIB_LAG	   0x20	/* listener address group */
#define GPIB_UNL	   0x3f	/* unlisten */
#define GPIB_TAG	   0x40	/* talker address group */
#define GPIB_UNT	   0x5f	/* untalk */
#define GPIB_SCA	   0x60	/* secondary address group */
#define GPIB_PPE	   0x60	/* parallel poll enable */
#define GPIB_PPD	   0x70	/* parallel poll disable */

/* IEEE-488.2 Status Byte register bits */
#define GPIB_4882_STB_MSS  0x40
#define GPIB_4882_STB_RQS  0x40
#define GPIB_4882_STB_ESB  0x20
#define GPIB_4882_STB_MAV  0x10

/* IEEE-488.2 Standard Event Status Register bits */

#define GPIB_4882_ESR_PON  0x80
#define GPIB_4882_ESR_URQ  0x40
#define GPIB_4882_ESR_CME  0x20
#define GPIB_4882_ESR_EXE  0x10
#define GPIB_4882_ESR_DDE  0x08
#define GPIB_4882_ESR_QYE  0x04
#define GPIB_4882_ESR_RQC  0x02
#define GPIB_4882_ESR_OPC  0x01

#endif 
